#include <set>
#include "parser.h"
#include "printer.h"
#include "polynomial.h"
#include "division.h"
#include "buchberger.h"
#include "wallideal.h"
#include "lp.h"
#include "reversesearch.h"
#include "termorder.h"
#include "gfanapplication.h"
#include "wallideal.h"


typedef set<IntegerVector,LexicographicTermOrder> VectorSet;

class ListStandardMonomialsApplication : public GFanApplication
{
  FieldOption theFieldOption;
  IntegerOption optionNumberOfBases;
public:
  bool includeInDefaultInstallation()
  {
    return false;
  }
  const char *helpText()
  {
    return "help.\n";
  }
  ListStandardMonomialsApplication():
    optionNumberOfBases("-n","undocumented",1)
  {
    registerOptions();
  }
  
  char *name()
  {
    return "_liststandardmonomials";
  }

  int main()
  {
    fprintf(Stderr,"Command no longer supported.\n");
    assert(0);
    /*    LpSolver::printList(Stderr);
    lpSetSolver("cddgmp");
    
    FileParser P(Stdin);
    PolynomialSet s;
    int c=P.nextNonBlank();
    bool first=true;
    assert(P.isLeftBrackets(c));

    int counter=0;

    VectorSet l;

    int n=0;

    while(counter<optionNumberOfBases.getValue() && ','==c || first)
      {
	PolynomialSet temp=P.parsePolynomialSet();

	for(PolynomialSet::const_iterator i=temp.begin();i!=temp.end();i++)
	  {
	    IntegerVector initialVector=i->getMarked().m.exponent;

	    if(n==0)n=initialVector.size();
	    assert(n==initialVector.size());
	    for(TermMap::const_iterator j=i->terms.begin();j!=i->terms.end();j++)
	    {
	      IntegerVector current=j->first.exponent;

	      if(current!=initialVector)
		{
		  IntegerVector v(current.size());
		 
		  while(true)
		    {
		      l.insert(v);
		      int i=0;
		      do
			{
			  if(v[i]<current[i])
			    {
			      v[i]++;
			      break;
			    }
			  else
			    v[i]=0;
			  i++;
			}
		      while(i<v.size());
		      if(i>=v.size())break;
		    }
		}
	    }
	  }

	fprintf(Stderr,"size:%i\n",l.size());

	c=P.nextNonBlank();
	first=false;
	counter++;
      }
    //    assert(P.isRightBrackets(c));

    IntegerVectorList temp;
    for(VectorSet::const_iterator i=l.begin();i!=l.end();i++)
      temp.push_back(*i);
    AsciiPrinter(Stdout).printVectorList(temp);

    */
    return 0;
  }
};

static ListStandardMonomialsApplication theApplication;
